diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/three-gpp-channel-model.h ns-3.31/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.30.1/src/spectrum/model/three-gpp-channel-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/spectrum/model/three-gpp-channel-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,263 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015, NYU WIRELESS, Tandon School of Engineering,
+ * New York University
+ * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef THREE_GPP_CHANNEL_H
+#define THREE_GPP_CHANNEL_H
+
+#include  <complex.h>
+#include "ns3/angles.h"
+#include <ns3/object.h>
+#include <ns3/nstime.h>
+#include <ns3/random-variable-stream.h>
+#include <ns3/boolean.h>
+#include <unordered_map>
+#include <ns3/channel-condition-model.h>
+#include <ns3/matrix-based-channel-model.h>
+
+namespace ns3 {
+
+class MobilityModel;
+
+/**
+ * \ingroup spectrum
+ * \brief Channel Matrix Generation following 3GPP TR 38.901
+ *
+ * The class implements the channel matrix generation procedure
+ * described in 3GPP TR 38.901.
+ *
+ * \see GetChannel
+ */
+class ThreeGppChannelModel : public MatrixBasedChannelModel
+{
+public:
+  /**
+   * Constructor
+   */
+  ThreeGppChannelModel ();
+
+  /**
+   * Destructor
+   */
+  ~ThreeGppChannelModel ();
+  
+  void DoDispose () override;
+
+  /**
+   * Get the type ID
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId ();
+
+
+  /**
+   * Set the channel condition model
+   * \param a pointer to the ChannelConditionModel object
+   */
+  void SetChannelConditionModel (Ptr<ChannelConditionModel> model);
+
+  /**
+   * Get the associated channel condition model
+   * \return a pointer to the ChannelConditionModel object
+   */
+  Ptr<ChannelConditionModel> GetChannelConditionModel () const;
+
+  /**
+   * Sets the center frequency of the model
+   * \param f the center frequency in Hz
+   */
+  void SetFrequency (double f);
+
+  /**
+   * Returns the center frequency
+   * \return the center frequency in Hz
+   */
+  double GetFrequency (void) const;
+
+  /**
+   * Sets the propagation scenario
+   * \param scenario the propagation scenario
+   */
+  void SetScenario (const std::string &scenario);
+
+  /**
+   * Returns the propagation scenario
+   * \return the propagation scenario
+   */
+  std::string GetScenario (void) const;
+
+  /**
+   * Looks for the channel matrix associated to the aMob and bMob pair in m_channelMap.
+   * If found, it checks if it has to be updated. If not found or if it has to
+   * be updated, it generates a new uncorrelated channel matrix using the
+   * method GetNewChannel and updates m_channelMap.
+   *
+   * \param aMob mobility model of the a device
+   * \param bMob mobility model of the b device
+   * \param aAntenna antenna of the a device
+   * \param bAntenna antenna of the b device
+   * \return the channel matrix
+   */
+  Ptr<const ChannelMatrix> GetChannel (Ptr<const MobilityModel> aMob,
+                                       Ptr<const MobilityModel> bMob,
+                                       Ptr<const ThreeGppAntennaArrayModel> aAntenna,
+                                       Ptr<const ThreeGppAntennaArrayModel> bAntenna) override;
+  /**
+   * \brief Assign a fixed random variable stream number to the random variables
+   * used by this model.
+   *
+   * \param stream first stream index to use
+   * \return the number of stream indices assigned by this model
+   */
+  int64_t AssignStreams (int64_t stream);
+
+private:
+  /**
+   * Extends the struct ChannelMatrix by including information that are used 
+   * within the class ThreeGppChannelModel
+   */
+  struct ThreeGppChannelMatrix : public MatrixBasedChannelModel::ChannelMatrix
+  {
+    bool m_los; //!< true if LOS, false if NLOS
+    
+    // TODO these are not currently used, they have to be correctly set when including the spatial consistent update procedure
+    /*The following parameters are stored for spatial consistent updating. The notation is 
+    that of 3GPP technical reports, but it can apply also to other channel realizations*/
+    MatrixBasedChannelModel::Double2DVector m_nonSelfBlocking; //!< store the blockages
+    Vector m_preLocUT; //!< location of UT when generating the previous channel
+    Vector m_locUT; //!< location of UT
+    MatrixBasedChannelModel::Double2DVector m_norRvAngles; //!< stores the normal variable for random angles angle[cluster][id] generated for equation (7.6-11)-(7.6-14), where id = 0(aoa),1(zoa),2(aod),3(zod)
+    double m_DS; //!< delay spread
+    double m_K; //!< K factor
+    uint8_t m_numCluster; //!< reduced cluster number;
+    MatrixBasedChannelModel::Double3DVector m_clusterPhase; //!< the initial random phases
+    bool m_o2i; //!< true if O2I
+    Vector m_speed; //!< velocity
+    double m_dis2D; //!< 2D distance between tx and rx
+    double m_dis3D; //!< 3D distance between tx and rx
+  };
+
+  /**
+   * Data structure that stores the parameters of 3GPP TR 38.901, Table 7.5-6,
+   * for a certain scenario
+   */
+  struct ParamsTable : public SimpleRefCount<ParamsTable>
+  {
+    uint8_t m_numOfCluster = 0;
+    uint8_t m_raysPerCluster = 0;
+    double m_uLgDS = 0;
+    double m_sigLgDS = 0;
+    double m_uLgASD = 0;
+    double m_sigLgASD = 0;
+    double m_uLgASA = 0;
+    double m_sigLgASA = 0;
+    double m_uLgZSA = 0;
+    double m_sigLgZSA = 0;
+    double m_uLgZSD = 0;
+    double m_sigLgZSD = 0;
+    double m_offsetZOD = 0;
+    double m_cDS = 0;
+    double m_cASD = 0;
+    double m_cASA = 0;
+    double m_cZSA = 0;
+    double m_uK = 0;
+    double m_sigK = 0;
+    double m_rTau = 0;
+    double m_uXpr = 0;
+    double m_sigXpr = 0;
+    double m_perClusterShadowingStd = 0;
+
+    double m_sqrtC[7][7];
+  };
+
+  /**
+   * Get the parameters needed to apply the channel generation procedure
+   * \param los the LOS/NLOS condition
+   * \param o2i whether if it is an outdoor to indoor transmission
+   * \param hBS the height of the BS
+   * \param hUT the height of the UT
+   * \param distance2D the 2D distance between tx and rx
+   * \return the parameters table
+   */
+  Ptr<const ParamsTable> GetThreeGppTable (bool los, bool o2i, double hBS, double hUT, double distance2D) const;
+
+  /**
+   * Compute the channel matrix between two devices using the procedure
+   * described in 3GPP TR 38.901
+   * \param locUT the location of the UT
+   * \param los the LOS/NLOS condition
+   * \param o2i whether if it is an outdoor to indoor transmission
+   * \param sAntenna the s node antenna array
+   * \param uAntenna the u node antenna array
+   * \param uAngle the u node angle
+   * \param sAngle the s node angle
+   * \param dis2D the 2D distance between tx and rx
+   * \param hBS the height of the BS
+   * \param hUT the height of the UT
+   * \return the channel realization
+   */
+  Ptr<ThreeGppChannelMatrix> GetNewChannel (Vector locUT, bool los, bool o2i,
+                                            Ptr<const ThreeGppAntennaArrayModel> sAntenna,
+                                            Ptr<const ThreeGppAntennaArrayModel> uAntenna,
+                                            Angles &uAngle, Angles &sAngle,
+                                            double dis2D, double hBS, double hUT) const;
+
+  /**
+   * Applies the blockage model A described in 3GPP TR 38.901
+   * \param params the channel matrix
+   * \param clusterAOA vector containing the azimuth angle of arrival for each cluster
+   * \param clusterZOA vector containing the zenith angle of arrival for each cluster
+   * \return vector containing the power attenuation for each cluster
+   */
+  DoubleVector CalcAttenuationOfBlockage (Ptr<ThreeGppChannelMatrix> params,
+                                          const DoubleVector &clusterAOA,
+                                          const DoubleVector &clusterZOA) const;
+
+  /**
+   * Check if the channel matrix has to be updated
+   * \param channelMatrix channel matrix
+   * \param isLos the current los condition
+   * \return true if the channel matrix has to be updated, false otherwise
+   */
+  bool ChannelMatrixNeedsUpdate (Ptr<const ThreeGppChannelMatrix> channelMatrix, bool isLos) const;
+
+  std::unordered_map<uint32_t, Ptr<ThreeGppChannelMatrix> > m_channelMap; //!< map containing the channel realizations
+  Time m_updatePeriod; //!< the channel update period
+  double m_frequency; //!< the operating frequency
+  std::string m_scenario; //!< the 3GPP scenario
+  Ptr<ChannelConditionModel> m_channelConditionModel; //!< the channel condition model
+  Ptr<UniformRandomVariable> m_uniformRv; //!< uniform random variable
+  Ptr<NormalRandomVariable> m_normalRv; //!< normal random variable
+
+  // parameters for the blockage model
+  bool m_blockage; //!< enables the blockage model A
+  uint16_t m_numNonSelfBlocking; //!< number of non-self-blocking regions
+  bool m_portraitMode; //!< true if potrait mode, false if landscape
+  double m_blockerSpeed; //!< the blocker speed
+
+  static const uint8_t PHI_INDEX = 0; //!< index of the PHI value in the m_nonSelfBlocking array
+  static const uint8_t X_INDEX = 1; //!< index of the X value in the m_nonSelfBlocking array
+  static const uint8_t THETA_INDEX = 2; //!< index of the THETA value in the m_nonSelfBlocking array
+  static const uint8_t Y_INDEX = 3; //!< index of the Y value in the m_nonSelfBlocking array
+  static const uint8_t R_INDEX = 4; //!< index of the R value in the m_nonSelfBlocking array
+};
+} // namespace ns3
+
+#endif /* THREE_GPP_CHANNEL_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc ns-3.31/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc
--- ns-3.30.1/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,319 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015, NYU WIRELESS, Tandon School of Engineering,
+ * New York University
+ * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include "ns3/log.h"
+#include "three-gpp-spectrum-propagation-loss-model.h"
+#include "ns3/net-device.h"
+#include "ns3/three-gpp-antenna-array-model.h"
+#include "ns3/node.h"
+#include "ns3/channel-condition-model.h"
+#include "ns3/double.h"
+#include "ns3/string.h"
+#include "ns3/simulator.h"
+#include "ns3/pointer.h"
+#include <map>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("ThreeGppSpectrumPropagationLossModel");
+
+NS_OBJECT_ENSURE_REGISTERED (ThreeGppSpectrumPropagationLossModel);
+
+ThreeGppSpectrumPropagationLossModel::ThreeGppSpectrumPropagationLossModel ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+ThreeGppSpectrumPropagationLossModel::~ThreeGppSpectrumPropagationLossModel ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+ThreeGppSpectrumPropagationLossModel::DoDispose ()
+{
+  m_deviceAntennaMap.clear ();
+  m_longTermMap.clear ();
+  m_channelModel->Dispose ();
+  m_channelModel = nullptr;
+}
+
+TypeId
+ThreeGppSpectrumPropagationLossModel::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::ThreeGppSpectrumPropagationLossModel")
+    .SetParent<SpectrumPropagationLossModel> ()
+    .SetGroupName ("Spectrum")
+    .AddConstructor<ThreeGppSpectrumPropagationLossModel> ()
+    .AddAttribute("ChannelModel", 
+                  "The channel model. It needs to implement the MatrixBasedChannelModel interface",
+                  StringValue("ns3::ThreeGppChannelModel"),
+                  MakePointerAccessor (&ThreeGppSpectrumPropagationLossModel::SetChannelModel,
+                                       &ThreeGppSpectrumPropagationLossModel::GetChannelModel),
+      MakePointerChecker<MatrixBasedChannelModel> ())
+    ;
+  return tid;
+}
+
+void
+ThreeGppSpectrumPropagationLossModel::SetChannelModel (Ptr<MatrixBasedChannelModel> channel)
+{
+  m_channelModel = channel;
+}
+
+Ptr<MatrixBasedChannelModel>
+ThreeGppSpectrumPropagationLossModel::GetChannelModel () const
+{
+  return m_channelModel;
+}
+
+void
+ThreeGppSpectrumPropagationLossModel::AddDevice (Ptr<NetDevice> n, Ptr<const ThreeGppAntennaArrayModel> a)
+{
+  NS_ASSERT_MSG (m_deviceAntennaMap.find (n->GetNode ()->GetId ()) == m_deviceAntennaMap.end (), "Device is already present in the map");
+  m_deviceAntennaMap.insert (std::make_pair (n->GetNode ()->GetId (), a));
+}
+
+double
+ThreeGppSpectrumPropagationLossModel::GetFrequency () const
+{
+  DoubleValue freq;
+  m_channelModel->GetAttribute ("Frequency", freq);
+  return freq.Get ();
+}
+
+void
+ThreeGppSpectrumPropagationLossModel::SetChannelModelAttribute (const std::string &name, const AttributeValue &value)
+{
+  m_channelModel->SetAttribute (name, value);
+}
+
+void
+ThreeGppSpectrumPropagationLossModel::GetChannelModelAttribute (const std::string &name, AttributeValue &value) const
+{
+  m_channelModel->GetAttribute (name, value);
+}
+
+ThreeGppAntennaArrayModel::ComplexVector
+ThreeGppSpectrumPropagationLossModel::CalcLongTerm (Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
+                                                    const ThreeGppAntennaArrayModel::ComplexVector &sW,
+                                                    const ThreeGppAntennaArrayModel::ComplexVector &uW) const
+{
+  NS_LOG_FUNCTION (this);
+
+  uint16_t sAntenna = static_cast<uint16_t> (sW.size ());
+  uint16_t uAntenna = static_cast<uint16_t> (uW.size ());
+
+  NS_LOG_DEBUG ("CalcLongTerm with sAntenna " << sAntenna << " uAntenna " << uAntenna);
+  //store the long term part to reduce computation load
+  //only the small scale fading needs to be updated if the large scale parameters and antenna weights remain unchanged.
+  ThreeGppAntennaArrayModel::ComplexVector longTerm;
+  uint8_t numCluster = static_cast<uint8_t> (params->m_channel[0][0].size ());
+
+  for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
+    {
+      std::complex<double> txSum (0,0);
+      for (uint16_t sIndex = 0; sIndex < sAntenna; sIndex++)
+        {
+          std::complex<double> rxSum (0,0);
+          for (uint16_t uIndex = 0; uIndex < uAntenna; uIndex++)
+            {
+              rxSum = rxSum + uW[uIndex] * params->m_channel[uIndex][sIndex][cIndex];
+            }
+          txSum = txSum + sW[sIndex] * rxSum;
+        }
+      longTerm.push_back (txSum);
+    }
+  return longTerm;
+}
+
+Ptr<SpectrumValue>
+ThreeGppSpectrumPropagationLossModel::CalcBeamformingGain (Ptr<SpectrumValue> txPsd,
+                                                           ThreeGppAntennaArrayModel::ComplexVector longTerm,
+                                                           Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
+                                                           const ns3::Vector &sSpeed, const ns3::Vector &uSpeed) const
+{
+  NS_LOG_FUNCTION (this);
+
+  Ptr<SpectrumValue> tempPsd = Copy<SpectrumValue> (txPsd);
+
+  //channel[rx][tx][cluster]
+  uint8_t numCluster = static_cast<uint8_t> (params->m_channel[0][0].size ());
+
+  // compute the doppler term
+  // NOTE the update of Doppler is simplified by only taking the center angle of
+  // each cluster in to consideration.
+  double slotTime = Simulator::Now ().GetSeconds ();
+  ThreeGppAntennaArrayModel::ComplexVector doppler;
+  for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
+    {
+      //cluster angle angle[direction][n],where, direction = 0(aoa), 1(zoa).
+      // TODO should I include the "alfa" term for the Doppler of delayed paths?
+      double temp_doppler = 2 * M_PI * ((sin (params->m_angle[MatrixBasedChannelModel::ZOA_INDEX][cIndex] * M_PI / 180) * cos (params->m_angle[MatrixBasedChannelModel::AOA_INDEX][cIndex] * M_PI / 180) * uSpeed.x
+                                         + sin (params->m_angle[MatrixBasedChannelModel::ZOA_INDEX][cIndex] * M_PI / 180) * sin (params->m_angle[MatrixBasedChannelModel::AOA_INDEX][cIndex] * M_PI / 180) * uSpeed.y
+                                         + cos (params->m_angle[MatrixBasedChannelModel::ZOA_INDEX][cIndex] * M_PI / 180) * uSpeed.z)
+                                         + (sin (params->m_angle[MatrixBasedChannelModel::ZOD_INDEX][cIndex] * M_PI / 180) * cos (params->m_angle[MatrixBasedChannelModel::AOD_INDEX][cIndex] * M_PI / 180) * sSpeed.x
+                                         + sin (params->m_angle[MatrixBasedChannelModel::ZOD_INDEX][cIndex] * M_PI / 180) * sin (params->m_angle[MatrixBasedChannelModel::AOD_INDEX][cIndex] * M_PI / 180) * sSpeed.y
+                                         + cos (params->m_angle[MatrixBasedChannelModel::ZOD_INDEX][cIndex] * M_PI / 180) * sSpeed.z))
+        * slotTime * GetFrequency () / 3e8;
+      doppler.push_back (exp (std::complex<double> (0, temp_doppler)));
+    }
+
+  // apply the doppler term and the propagation delay to the long term component
+  // to obtain the beamforming gain
+  auto vit = tempPsd->ValuesBegin (); // psd iterator
+  auto sbit = tempPsd->ConstBandsBegin(); // band iterator
+  while (vit != tempPsd->ValuesEnd ())
+    {
+      std::complex<double> subsbandGain (0.0,0.0);
+      if ((*vit) != 0.00)
+        {
+          double fsb = (*sbit).fc; // center frequency of the sub-band
+          for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
+            {
+              double delay = -2 * M_PI * fsb * (params->m_delay[cIndex]);
+              subsbandGain = subsbandGain + longTerm[cIndex] * doppler[cIndex] * exp (std::complex<double> (0, delay));
+            }
+          *vit = (*vit) * (norm (subsbandGain));
+        }
+      vit++;
+      sbit++;
+    }
+  return tempPsd;
+}
+
+ThreeGppAntennaArrayModel::ComplexVector
+ThreeGppSpectrumPropagationLossModel::GetLongTerm (uint32_t aId, uint32_t bId,
+                                                   Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+                                                   const ThreeGppAntennaArrayModel::ComplexVector &aW,
+                                                   const ThreeGppAntennaArrayModel::ComplexVector &bW) const
+{
+  ThreeGppAntennaArrayModel::ComplexVector longTerm; // vector containing the long term component for each cluster
+
+  // check if the channel matrix was generated considering a as the s-node and
+  // b as the u-node or viceversa
+  ThreeGppAntennaArrayModel::ComplexVector sW, uW;
+  if (!channelMatrix->IsReverse (aId, bId))
+  {
+    sW = aW;
+    uW = bW;
+  }
+  else
+  {
+    sW = bW;
+    uW = aW;
+  }
+
+  // compute the long term key, the key is unique for each tx-rx pair
+  uint32_t x1 = std::min (aId, bId);
+  uint32_t x2 = std::max (aId, bId);
+  uint32_t longTermId = MatrixBasedChannelModel::GetKey (x1, x2);
+
+  bool update = false; // indicates whether the long term has to be updated
+  bool notFound = false; // indicates if the long term has not been computed yet
+
+  // look for the long term in the map and check if it is valid
+  if (m_longTermMap.find (longTermId) != m_longTermMap.end ())
+  {
+    NS_LOG_DEBUG ("found the long term component in the map");
+    longTerm = m_longTermMap[longTermId]->m_longTerm;
+
+    // check if the channel matrix has been updated
+    // or the s beam has been changed
+    // or the u beam has been changed
+    update = (m_longTermMap[longTermId]->m_channel->m_generatedTime != channelMatrix->m_generatedTime
+              || m_longTermMap[longTermId]->m_sW != sW
+              || m_longTermMap[longTermId]->m_uW != uW);
+
+  }
+  else
+  {
+    NS_LOG_DEBUG ("long term component NOT found");
+    notFound = true;
+  }
+
+  if (update || notFound)
+    {
+      NS_LOG_DEBUG ("compute the long term");
+      // compute the long term component
+      longTerm = CalcLongTerm (channelMatrix, sW, uW);
+
+      // store the long term
+      Ptr<LongTerm> longTermItem = Create<LongTerm> ();
+      longTermItem->m_longTerm = longTerm;
+      longTermItem->m_channel = channelMatrix;
+      longTermItem->m_sW = sW;
+      longTermItem->m_uW = uW;
+
+      m_longTermMap[longTermId] = longTermItem;
+    }
+
+  return longTerm;
+}
+
+Ptr<SpectrumValue>
+ThreeGppSpectrumPropagationLossModel::DoCalcRxPowerSpectralDensity (Ptr<const SpectrumValue> txPsd,
+                                                                    Ptr<const MobilityModel> a,
+                                                                    Ptr<const MobilityModel> b) const
+{
+  NS_LOG_FUNCTION (this);
+  uint32_t aId = a->GetObject<Node> ()->GetId (); // id of the node a
+  uint32_t bId = b->GetObject<Node> ()->GetId (); // id of the node b
+
+  NS_ASSERT (aId != bId);
+  NS_ASSERT_MSG (a->GetDistanceFrom (b) > 0.0, "The position of a and b devices cannot be the same");
+
+  Ptr<SpectrumValue> rxPsd = Copy<SpectrumValue> (txPsd);
+
+  // retrieve the antenna of device a
+  NS_ASSERT_MSG (m_deviceAntennaMap.find (aId) != m_deviceAntennaMap.end (), "Antenna not found for node " << aId);
+  Ptr<const ThreeGppAntennaArrayModel> aAntenna = m_deviceAntennaMap.at (aId);
+  NS_LOG_DEBUG ("a node " << a->GetObject<Node> () << " antenna " << aAntenna);
+
+  // retrieve the antenna of the device b
+  NS_ASSERT_MSG (m_deviceAntennaMap.find (bId) != m_deviceAntennaMap.end (), "Antenna not found for device " << bId);
+  Ptr<const ThreeGppAntennaArrayModel> bAntenna = m_deviceAntennaMap.at (bId);
+  NS_LOG_DEBUG ("b node " << bId << " antenna " << bAntenna);
+
+  if (aAntenna->IsOmniTx () || bAntenna->IsOmniTx () )
+    {
+      NS_LOG_LOGIC ("Omni transmission, do nothing.");
+      return rxPsd;
+    }
+
+  Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix = m_channelModel->GetChannel (a, b, aAntenna, bAntenna);
+
+  // get the precoding and combining vectors
+  ThreeGppAntennaArrayModel::ComplexVector aW = aAntenna->GetBeamformingVector ();
+  ThreeGppAntennaArrayModel::ComplexVector bW = bAntenna->GetBeamformingVector ();
+
+  // retrieve the long term component
+  ThreeGppAntennaArrayModel::ComplexVector longTerm = GetLongTerm (aId, bId, channelMatrix, aW, bW);
+
+  // apply the beamforming gain
+  rxPsd = CalcBeamformingGain (rxPsd, longTerm, channelMatrix, a->GetVelocity (), b->GetVelocity ());
+
+  return rxPsd;
+}
+
+
+}  // namespace ns3
